# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Tasks

* [`create_host`](#create_host): Create a host in foreman from a template
* [`get_host`](#get_host): Get information about a host from foreman
* [`update_host`](#update_host): Update a host in foreman from a template

### Plans

* [`foreman_hammer::hosts`](#foreman_hammerhosts): Create or update an existing host from a list of hosts with hammer_cli in foreman

## Tasks

### `create_host`

Create a host in foreman from a template

**Supports noop?** true

#### Parameters

##### `hostname`

Data type: `Stdlib::Host`

The Hostname. e.g. mail01

##### `template`

Data type: `String[1]`

The template to create the host from

##### `ip`

Data type: `Optional[Stdlib::IP::Address::V4]`

The ip for the primary interface

##### `cpus`

Data type: `Optional[Integer]`

The number of CPU cores

##### `mem`

Data type: `Optional[Integer]`

The amount of memory in GB

##### `template_basedir`

Data type: `String[1]`

The template basedir.

##### `template_vars`

Data type: `Hash`

Variables to build the YAML with Jinja2

##### `hammer_cli_bin`

Data type: `Optional[String]`

The base path under which the hammer is installed.

##### `server_url`

Data type: `Optional[Stdlib::Httpsurl]`

URL to access foreman e.g. https://foreman.example.com

##### `username`

Data type: `Optional[String[1]]`

Username to access foreman

##### `password`

Data type: `Optional[String[1]]`

Password for foreman.

##### `verbose`

Data type: `Boolean`

Turn on verbose mode. Show passwords in noop mode.

### `get_host`

Get information about a host from foreman

**Supports noop?** true

#### Parameters

##### `name`

Data type: `Stdlib::Fqdn`

The name of the host to get information about e.g. mail01.example.net

##### `hammer_cli_bin`

Data type: `Optional[String]`

The base path under which the hammer is installed.

##### `server_url`

Data type: `Optional[Stdlib::Httpsurl]`

URL to access foreman e.g. https://foreman.example.com

##### `username`

Data type: `Optional[String[1]]`

Username to access foreman

##### `password`

Data type: `Optional[String[1]]`

Password for foreman.

##### `verbose`

Data type: `Boolean`

Turn on verbose mode. Show passwords in noop mode.

### `update_host`

Update a host in foreman from a template

**Supports noop?** true

#### Parameters

##### `id`

Data type: `Integer`

The ID for the host from foreman.

##### `template`

Data type: `String`

The template to update the host from

##### `build`

Data type: `Optional[Boolean]`

Should foreman rebuild the host?

##### `ip`

Data type: `Optional[Stdlib::IP::Address::V4]`

The ip for the primary interface

##### `cpus`

Data type: `Optional[Integer]`

The number of CPU cores

##### `mem`

Data type: `Optional[Integer]`

The amount of memory in GB

##### `template_basedir`

Data type: `String`

The template basedir.

##### `template_vars`

Data type: `Hash`

Variables to build the YAML with Jinja2

##### `hammer_cli_bin`

Data type: `Optional[String]`

The base path under which the hammer is installed.

##### `server_url`

Data type: `Optional[Stdlib::Httpsurl]`

URL to access foreman e.g. https://foreman.example.com

##### `username`

Data type: `Optional[String[1]]`

Username to access foreman

##### `password`

Data type: `Optional[String[1]]`

Password for foreman.

##### `verbose`

Data type: `Boolean`

Turn on verbose mode. Show passwords in noop mode.

## Plans

### `foreman_hammer::hosts`

Create or update an existing host from a list of hosts with hammer_cli in foreman

#### Parameters

The following parameters are available in the `foreman_hammer::hosts` plan.

##### `targets`

Data type: `TargetSpec`

The list of targets to run the plan

##### `lookup_key`

Data type: `String`

The hiera base lookup key.

Default value: `'foreman_hammer'`

##### `hosts`

Data type: `Hash`

A list of hosts to create or update.

Default value: `lookup("${lookup_key}::hosts", Hash, 'deep', {})`

##### `template_basedir`

Data type: `String`

The base directory for the foreman yaml templates

Default value: `lookup("${lookup_key}::template_basedir", String, 'deep', 'data/host_templates')`

##### `noop`

Data type: `Boolean`

Turn on noop mode.

Default value: ``false``

##### `verbose`

Data type: `Boolean`

Turn on verbose mode.

Default value: ``false``

